----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    17:25:54 10/21/2015 
-- Design Name: 
-- Module Name:    extKey - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity extKey is
    Port ( Z      : in std_logic_vector(3 downto 0);
           i : in  STD_LOGIC_VECTOR (4 downto 0);
           counter : in std_logic_vector(2 downto 0);
           rk_o : out  STD_LOGIC_VECTOR (3 downto 0));
end extKey;

architecture Behavioral of extKey is

-- Component
component xor4to4 is
    Port ( nible_1_i : in  STD_LOGIC_VECTOR (3 downto 0);
           nible_2_i : in  STD_LOGIC_VECTOR (3 downto 0);
           nible_o : out  STD_LOGIC_VECTOR (3 downto 0));
end component;

component sbox is
		port(
			nibble_in : in std_logic_vector(3 downto 0);
			nibble_out: out std_logic_vector(3 downto 0)
		);
end component;

-- Signal
signal sbox_o : std_logic_vector(3 downto 0);

begin

Sbox_c : sbox port map(
  nibble_in => Z,
  nibble_out => sbox_o
);

with counter(2 downto 0) select
		rk_o <=
			sbox_o xor i(4 downto 1) when "111",
      sbox_o xor (i(0) & "000") when "110",
			sbox_o when others;

end Behavioral;

