------------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand  
-- 
-- Create Date:    11:11:23 10/21/2015 
-- Design Name: 
-- Module Name:    round_f - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity round_f is
    Port ( nible_l1_i : in STD_LOGIC_VECTOR (3 downto 0);
           nible_r_i  : in STD_LOGIC_VECTOR (3 downto 0);
           rk : in  STD_LOGIC_VECTOR (3 downto 0);
           nible_o : out  STD_LOGIC_VECTOR (3 downto 0));
end round_f;

architecture Behavioral of round_f is

-- Components
component xor4to4 is
    Port ( nible_1_i : in  STD_LOGIC_VECTOR (3 downto 0);
           nible_2_i : in  STD_LOGIC_VECTOR (3 downto 0);
           nible_o : out  STD_LOGIC_VECTOR (3 downto 0));
end component;

component sbox is
		port(
			nibble_in : in std_logic_vector(3 downto 0);
			nibble_out: out std_logic_vector(3 downto 0)
		);
end component;

-- Signals
signal add_rk_o : STD_LOGIC_VECTOR (3 downto 0);
signal sbox_o : STD_LOGIC_VECTOR (3 downto 0);
signal nl_o : STD_LOGIC_VECTOR (3 downto 0);
signal L_1_i : STD_LOGIC_VECTOR (3 downto 0);

begin

add_rk : xor4to4 port map(
  nible_1_i => nible_r_i,
  nible_2_i => rk,
  nible_o   => add_rk_o
);

sbox_c : sbox port map(
  nibble_in   => add_rk_o,
  nibble_out  => sbox_o
);

nl : xor4to4 port map(
  nible_1_i => nible_l1_i,
  nible_2_i => sbox_o,
  nible_o   => nible_o
);

end Behavioral;

